﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.2
@EndOfDesignText@
'Class module
Sub Class_Globals
	Type ScrollingLabel (lbl As Label, Canvas As Canvas, Bitmap As Bitmap, _ 
		SrcRect As Rect, DestRect As Rect, MoveLeft As Boolean,Speed As Int,BackgroundColor As Int,tag As String ,TextColor As Int   )
	'Dim Gap As Int= 100dip
    Dim Timer1 As Timer 'The timer that controls the animation

	Dim CurrentScrollingText As ScrollingLabel
	Dim labelList As List
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
 	Timer1.Initialize("Timer1", 20)
	labelList.Initialize
	
End Sub
'Sub AddLable(lbl As Label)
'	
'End Sub
'Sub removeLable(lbl As Label)
'	
'End Sub
Sub StartScrolling (lbl As Label, txt As String, MoveLeft As Boolean,Speed As Int,SplitterBitmap As Bitmap,color As Int  ) As ScrollingLabel
	Dim SL As ScrollingLabel
	SL.Initialize
	SL.lbl = lbl
	SL.Canvas.Initialize(lbl)
	SL.Speed=Speed
	SL.tag =lbl.Tag 
	SL.BackgroundColor=color
	SL.TextColor = lbl.TextColor 
	
	
	
	'If SplitterBitmap.IsInitialized Then  Gap=SplitterBitmap.Width*3
	Dim width As Int,height As Int,gapwidth As Int,totalWidth As Int 
	Dim Found As Int=ListExists(SL), CenterStart As Int ,CenterEnd As Int 
	height =SL.Canvas.MeasureStringHeight(txt, lbl.Typeface, lbl.TextSize)
	gapwidth = SL.Canvas.MeasureStringWidth("HH", lbl.Typeface, lbl.TextSize)
	CenterStart=lbl.Height/2-height/2
	CenterEnd=CenterStart+height
 
	
	If Found=-1 Then 
		labelList.Add(SL)
	Else
		labelList.RemoveAt (Found)
		labelList.Add (SL)
		
	End If
	
	

	
	Dim TxtArr() As String
	TxtArr=Regex.Split(CRLF,txt)
	totalWidth=SL.Canvas.MeasureStringWidth(txt , lbl.Typeface, lbl.TextSize)+lbl.Width+TxtArr.Length*gapwidth
	
	Dim b As Bitmap
	b.InitializeMutable(totalWidth, lbl.Height)
	
	Dim c As Canvas
	c.Initialize2(b)

	
	Dim CurrPos As Int
		Select Case MoveLeft
			Case True
				CurrPos=lbl.Width
		
			Case False
				CurrPos=0
		End Select
						
	For Each str As String In TxtArr
		width=SL.Canvas.MeasureStringWidth(str, lbl.Typeface, lbl.TextSize)'+gapwidth
		
		Select Case MoveLeft
			Case True
				c.DrawText(str, CurrPos, CenterStart+height, lbl.Typeface, lbl.TextSize, lbl.TextColor, "LEFT")
				'----------------- DRAW SPLITTER IMAGE
				If SplitterBitmap.IsInitialized Then 
					Dim separatorRect As Rect
					''''separatorRect.Initialize(CurrPos+width ,(b.Height/2)-(height-2) ,CurrPos+width+gapwidth,(b.Height/2)+(height/4)  )
					separatorRect.Initialize(CurrPos+width ,CenterStart,CurrPos+width+gapwidth,CenterEnd  )
					c.DrawBitmap(SplitterBitmap,Null,separatorRect)
				End If
			
			Case False
				
				''''c.DrawText(str,-CurrPos  , CenterStart+height, lbl.Typeface, lbl.TextSize, lbl.TextColor, "RIGHT")
				c.DrawText(str,totalWidth-CurrPos-width-lbl.Width  , CenterStart+height, lbl.Typeface, lbl.TextSize, lbl.TextColor, "LEFT")
				'|-------------------------|=============||
				'|          |--WIDTH2--|  |----WIDTH1----||
				'|                 |------LBL WIDTH -----||
				'|-------------TOTALWIDTH-----------------|
				
				'----------------- DRAW SPLITTER IMAGE
				If SplitterBitmap.IsInitialized Then 
					Dim separatorRect As Rect
					separatorRect.Initialize(totalWidth-CurrPos-width-lbl.Width  -gapwidth ,CenterStart ,totalWidth-CurrPos-width-lbl.Width  ,CenterEnd  )
					''''separatorRect.Initialize(-CurrPos +width ,CenterStart ,-CurrPos+width+gapwidth  ,CenterEnd  )
					c.DrawBitmap(SplitterBitmap,Null,separatorRect)
				End If
				
		End Select

				CurrPos=CurrPos+width+gapwidth	
	Next

	'-------------------------------------------------
	SL.SrcRect.Initialize(0, 0, lbl.width, lbl.Height)
	SL.DestRect.Initialize(0, 0, lbl.width, lbl.Height)
	
	
	SL.Bitmap = b
	SL.Canvas.DrawBitmap(SL.Bitmap, SL.SrcRect, SL.DestRect)
	
	
	SL.lbl.Invalidate
	SL.MoveLeft = MoveLeft
	
	
	Timer1.Enabled=True 
	Return SL
End Sub
Sub ListExists(SL As ScrollingLabel) As Int 
	Dim foundItem As ScrollingLabel
	For i = 0 To labelList.Size -1
		foundItem=labelList.Get(i)
		If foundItem.Tag =SL.Tag  Then 
			Return i
		End If
		
	Next
	 
	Return -1
End Sub
Sub Timer1_Tick ()
	'Return
	For i = 0 To labelList.Size - 1
		Dim SL As ScrollingLabel
		SL = labelList.Get(i)
		
		If SL.MoveLeft = True Then
			SL.SrcRect.Left = SL.SrcRect.Left + (SL.Speed)
			SL.SrcRect.Right = SL.SrcRect.Left + SL.lbl.Width
			If SL.SrcRect.Right > SL.Bitmap.Width + SL.lbl.Width  Then
				SL.SrcRect.Left = 0
				SL.SrcRect.Right = SL.SrcRect.Left + SL.lbl.Width
			End If
		Else		
			SL.SrcRect.Left = SL.SrcRect.Left - (SL.Speed)
			SL.SrcRect.Right = SL.SrcRect.Left + SL.lbl.Width
			If SL.SrcRect.Left< -SL.lbl.Width Then
				SL.SrcRect.Left = SL.Bitmap.Width - SL.lbl.Width
				SL.SrcRect.Right = SL.SrcRect.Left + SL.lbl.Width
			End If
		End If
		
		SL.Canvas.DrawRect(SL.DestRect, SL.BackgroundColor  , True, 0)
	
		SL.Canvas.DrawBitmap(SL.Bitmap, SL.SrcRect, SL.DestRect)
		SL.lbl.Invalidate
	Next
End Sub